unit SMB;

interface

uses
  windows, sysutils, MyUtils, Forms;

var
  Data: dword;

function DlPortReadPortUchar(Port: cardinal): cardinal;
stdcall; external'dlportio.dll';
function DlPortReadPortUshort(Port: cardinal): cardinal;
stdcall; external'dlportio.dll';
function DlPortReadPortUlong(Port: cardinal): cardinal;
stdcall; external'dlportio.dll';
procedure DlPortWritePortUchar(Port: cardinal; Value: cardinal);
stdcall; external'dlportio.dll';
procedure DlPortWritePortUshort(Port: cardinal; Value: cardinal);
stdcall; external'dlportio.dll';
procedure DlPortWritePortUlong(Port: cardinal; Value: cardinal);
stdcall; external'dlportio.dll';

function smbGetReg(BaseAddr: word; Reg: byte; Slave: byte): word;
procedure smbSetReg(BaseAddr: word; Reg: byte; Chip_Add: byte; Data: byte);
function smbCallBus(BaseAddr: word; CMD: byte; Slave: byte; RW: byte): cardinal;
procedure smbWaitForFree(BaseAddr: word);
procedure smbWaitForEnd(BaseAddr: word);

const
  RW_WRITE = 0;
  RW_READ = 1;

implementation

procedure smbSetReg(BaseAddr: word; Reg: byte; Chip_Add: byte; Data: byte);
begin
  smbWaitForFree(BaseAddr);
  DlPortWritePortUshort(BaseAddr + 5, Data);
  DlPortWritePortUshort(BaseAddr + 6, Data);
  smbCallBus(BaseAddr, Reg, Chip_Add, 0);
end;

function smbGetReg(BaseAddr: word; Reg: byte; Slave: byte): word;
var
  Data: cardinal;
begin
  smbWaitForFree(BaseAddr);
  DlPortWritePortUchar(BaseAddr + 5, 0);
  DlPortWritePortUchar(BaseAddr + 6, 0);
  Data := smbCallBus(BaseAddr, Reg, Slave, RW_READ);
  Result := (Data and $ff);
end;

function smbGetAddress(BaseAddr: word): string;
var
  Data: word;
  Cheque: string;
  idx: integer;
begin
  Cheque := '';
  for idx := $20 to $4F do begin
    smbWaitForFree(BaseAddr);
    DlPortWritePortUchar(BaseAddr + 5, 0);
    DlPortWritePortUchar(BaseAddr + 6, 0);
    Data := smbCallBus(BaseAddr, 0, idx, RW_READ);
    if (Data and $FF) <> 0 then begin
      Cheque := Cheque + rStr('00' + Format('%x', [idx]), 2);
    end;
  end;
  Result := Cheque;
end;

function smbCallBus(BaseAddr: word; CMD: byte; Slave: byte; RW: byte): cardinal;
var
  Dump1: word;
begin
  smbWaitForFree(BaseAddr);
  DlPortWritePortUchar(BaseAddr + 3, CMD);
  DlPortWritePortUchar(BaseAddr + 4, (Slave shl 1) or RW);
  DlPortWritePortUchar(BaseAddr + 2, $48);
  sleep(1);
  Application.ProcessMessages;
  smbWaitForEnd(BaseAddr);
  Dump1 := ( DlPortReadPortUchar(BaseAddr + 6) shl 8);
  Dump1 := Dump1 or DlPortReadPortUchar(BaseAddr + 5);
  Result := Dump1;
end;

procedure smbWaitForFree(BaseAddr: word);
var
  Status: byte;
begin
  Status := DlPortReadPortUchar(BaseAddr);
  while (Status and 1) <> 0 do begin
    Application.ProcessMessages;
    Status := DlPortReadPortUchar(BaseAddr);
  end;
  if (Status and $1e) <> 0 then
    DlPortWritePortUchar(BaseAddr, Status);
end;

procedure smbWaitForEnd(BaseAddr: word);
var
  Status: byte;
begin
  Status := DlPortReadPortUchar(BaseAddr);
  while (Status and 1) = 1 do begin
    Application.ProcessMessages;
    Status := DlPortReadPortUchar(BaseAddr);
  end;
end;
end.
